const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");
exports.Appliance = void 0;

class Appliance {
    constructor(platform, accessory, ip_address, device_name,subnet_id,device_id,channel_id,value,status) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        this.status=status

        this.RelayLightbulbStates = {
            On: false,
        };

            if(value==false){

            this.accessory.getService(this.platform.Service.AccessoryInformation)
                .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
                .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Appliance");
            this.service = this.accessory.getService(this.platform.Service.Outlet) || this.accessory.addService(this.platform.Service.Outlet);
            this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);
            this.service.getCharacteristic(this.platform.Characteristic.On)
                .onSet(this.setOn.bind(this))
                .onGet(this.getOn.bind(this));

            }else{
              
                if(status!==null){
                    this.service = this.accessory.getService(this.platform.Service.Outlet) || this.accessory.addService(this.platform.Service.Outlet);
                    this.service.getCharacteristic(this.platform.Characteristic.On).updateValue(this.status);
                    this.RelayLightbulbStates.On=this.status
                
                }
                
            }
    }
    async setOn(value) {

        this.RelayLightbulbStates.On = value;

         let get_value
         if(value==true){
            get_value=100
         }else{
            get_value=0
         }

          let subnet_id=helper.numberToHex(this.subnet_id )
          let device_id=helper.numberToHex(this.device_id ) 
          let channel_id=helper.numberToHex(this.channel_id )
          
          get_value=helper.numberToHex(get_value)  
          let set_packet=String("0f01fefffe0031")+subnet_id+device_id+channel_id+get_value+"0000"
          let payload=set_packet
          let get_crc=crc_calculator.payload(payload)
          let send_packet=set_packet+get_crc
          let packet=helper.fullPacket(send_packet)
          let log_packet=helper.addSpace(packet)
          this.platform.log.debug(log_packet)
          send_to_server.udpclient(this.ip_address,packet)
    }
    async getOn() {

        return this.RelayLightbulbStates.On;
    }
}
exports.Appliance = Appliance;