
exports.Extra = void 0;

class Extra {
    constructor(platform, accessory,ip_address, device_name,subnet_id,device_id,channel_id) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address
        
        this.RelayLightbulbStates = {
            On: false,
        };

       

        this.accessory.getService(this.platform.Service.AccessoryInformation)
            .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
            .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Speaker");
        this.service = this.accessory.getService(this.platform.Service.Speaker) || this.accessory.addService(this.platform.Service.Speaker);
        this.service.setCharacteristic(this.platform.Characteristic.ConfiguredName, device_name);
        this.service.getCharacteristic(this.platform.Characteristic.Active)
            .onSet(this.setOn.bind(this))
            .onGet(this.getOn.bind(this));

        this.service.getCharacteristic(this.platform.Characteristic.Mute)
        .onSet(this.setMute.bind(this))
        .onGet(this.getMute.bind(this));

        this.service.getCharacteristic(this.platform.Characteristic.Volume)
        .onSet(this.setVolume.bind(this))
        .onGet(this.getVolume.bind(this));
 
    }
    async setOn(value) {
        this.platform.log(" set universal switch "+value)     
    }
    async getOn() {
        this.platform.log(" universal switch "+this.RelayLightbulbStates.On)
      
        return this.RelayLightbulbStates.On;
    }

    async setMute(value) {
        this.platform.log(" set mute "+value)
      
        
    }

    async getMute() {
        this.platform.log(" universal switch ")
      
        return 1;
    }

    async setVolume(value) {
        this.platform.log(" set Volume "+value)
      
        
    }

    async getVolume() {
        this.platform.log(" get volume ")
      
        return 10;
    }



}
exports.Extra = Extra;