
const crc_calculator = require("homebridge-tiscontrol-wired/app/crc/crc16");
const  send_to_server = require("homebridge-tiscontrol-wired/app/server");
const  helper = require("homebridge-tiscontrol-wired/app/helper");
const  device_status = require("homebridge-tiscontrol-wired/app/status");
exports.Thermostat = void 0;

class Thermostat {
    constructor(platform, accessory, ip_address,device_name,subnet_id,device_id,channel_id,value,status,scale) {
        this.platform = platform;
        this.accessory = accessory;
        this.device_name = device_name;
        this.subnet_id=subnet_id;
        this.device_id=device_id;
        this.channel_id=channel_id;
        this.ip_address=ip_address

        this.status_data=status
        this.scale=scale
        

        this.RelayLightbulbStates = {
            On: false,
        };

        //this.Thermostat=status

        this.Thermostat={

                On : false,
                THAmbient : 28,
                THSetpoint : 16,
                acstatus:1,
                autoTemperature:14,
                coolTemperature:14,
                dryTemperature:14,
                heatTemperature:14,
                currentmode:1,
                fanmode:2,
                Scale:0,
                setting_mode:"02"
        }


//         let one = { a: 1, b: 2, c: 3 };
// let two = { b: 20, c: 30, d: 40 };



       
          // this.Thermostat.THSetpoint=this.status_data.THSetpoint

          // this.light_on=new device_status.deviceStatus(this.Thermostat.THSetpoint)

          // this.platform.log.debug("add light status "+this.light_on.name)
    

        

        let minValue,maxValue,minStep
        if(this.scale=="Fahrenheit" || this.scale=="F"){

          minValue= 10,
          maxValue= 86,
          minStep= 1

        }else{

          minValue= 10,
          maxValue= 30,
          minStep= 1

        }

       

            this.accessory.getService(this.platform.Service.AccessoryInformation)
                .setCharacteristic(this.platform.Characteristic.Manufacturer, 'TIS Control')
                .setCharacteristic(this.platform.Characteristic.Manufacturer.Model, "Thermostat");
            this.service = this.accessory.getService(this.platform.Service.Thermostat) || this.accessory.addService(this.platform.Service.Thermostat);
            this.service.setCharacteristic(this.platform.Characteristic.Name, device_name);
            this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState)
                .onGet(this.getOn.bind(this)).setProps({
                  maxValue: 3,
                  minValue: 0,
                  validValues: [0,1,2,3]
                });

            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState)
            .onGet(this.handleTargetHeatingCoolingStateGet.bind(this))
            .onSet(this.handleTargetHeatingCoolingStateSet.bind(this));


            this.service.getCharacteristic(this.platform.Characteristic.CurrentTemperature)
            .onGet(this.handleCurrentTemperatureGet.bind(this));

            this.service.getCharacteristic(this.platform.Characteristic.TargetTemperature)
              .onGet(this.handleTargetTemperatureGet.bind(this)).setProps({
                minValue: minValue,
                maxValue: maxValue,
                minStep: minStep})
              .onSet(this.handleTargetTemperatureSet.bind(this));
        
            this.service.getCharacteristic(this.platform.Characteristic.TemperatureDisplayUnits)
              .onGet(this.handleTemperatureDisplayUnitsGet.bind(this))
              .onSet(this.handleTemperatureDisplayUnitsSet.bind(this));


        if(value){

          this.Thermostat.On=this.status_data.On
          this.Thermostat.currentmode=this.status_data.currentmode
          this.Thermostat.fanmode=this.status_data.fanmode
          this.Thermostat.THAmbient=this.status_data.THAmbient
          this.Thermostat.THSetpoint=this.status_data.THSetpoint
          this.Thermostat.acstatus=this.status_data.acstatus
          this.Thermostat.Scale=this.status_data.Scale
          this.Thermostat.coolTemperature=this.status_data.coolTemperature
          this.Thermostat.heatTemperature=this.status_data.heatTemperature
          this.Thermostat.autoTemperature=this.status_data.autoTemperature
          this.Thermostat.dryTemperature=this.status_data.dryTemperature
          this.Thermostat.setting_mode=this.status_data.setting_mode

 
           this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.Thermostat.currentmode)
          this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.Thermostat.currentmode)
          this.service.getCharacteristic(this.platform.Characteristic.CurrentTemperature).updateValue(this.Thermostat.THAmbient)
          this.service.getCharacteristic(this.platform.Characteristic.TargetTemperature).updateValue(this.Thermostat.THSetpoint)
          this.service.getCharacteristic(this.platform.Characteristic.TemperatureDisplayUnits).updateValue(this.Thermostat.Scale)
           
        }
        

    }
    async setOn(value) {
        this.platform.log.debug(" thermostat "+this.device_name )

        this.Thermostat.On = value;
    }
    async getOn() {
        
      let subnet_id=helper.numberToHex(this.subnet_id )
      let modify_channel_id=this.channel_id-1
      let device_id=helper.numberToHex(this.device_id) 
      let channel_id=helper.numberToHex(modify_channel_id) 

      let set_packet=String("0c01fefffee0ec")+subnet_id+device_id+channel_id
      let payload=set_packet
      let get_crc=crc_calculator.payload(payload)
      let send_packet=set_packet+get_crc
      let packet=helper.fullPacket(send_packet)
      let log_packet=helper.addSpace(packet)
      this.platform.log.debug(log_packet)
      send_to_server.udpclient(this.ip_address,packet)

        return this.Thermostat.On;
    }

    async handleCurrentHeatingCoolingStateGet() {
        this.platform.log.debug('Triggered GET CurrentHeatingCoolingState');
    
        // set this to a valid value for CurrentHeatingCoolingState
        const currentValue = this.Thermostat.acstatus
    
        return currentValue;
      }

      handleTargetHeatingCoolingStateGet() {
        this.platform.log.debug('Triggered GET TargetHeatingCoolingState');
    
        // set this to a valid value for TargetHeatingCoolingState
        const currentValue = this.Thermostat.acstatus
    
        return currentValue;
      }


      async handleTargetHeatingCoolingStateSet(value) {
       // this.platform.log.debug('Triggered SET TargetHeatingCoolingState:'+value);

           if(value==1 || value==2 || value==3){

            let subnet_id=helper.numberToHex(this.subnet_id )
            let modify_channel_id=this.channel_id-1
            let device_id=helper.numberToHex(this.device_id) 
            let channel_id=helper.numberToHex(modify_channel_id)
            let modified_native_mode=helper.modified_native_mode(value)
            
            let modify_setting_mode=modified_native_mode.toString()+this.Thermostat.fanmode.toString()

            this.platform.log.debug("Thermostat off mode excuted " + value)

            this.Thermostat.setting_mode=modify_setting_mode
            let coolTemperature= helper.numberToHex(this.Thermostat.coolTemperature)
            let heatTemperature=helper.numberToHex(this.Thermostat.heatTemperature)
            let autoTemperature=helper.numberToHex(this.Thermostat.autoTemperature)
            let dryTemperature= helper.numberToHex(this.Thermostat.dryTemperature)
            let setting_mode= this.Thermostat.setting_mode
            this.Thermostat.currentmode=value


            let set_packet=String("1401fefffee0ee")+subnet_id+device_id+channel_id+"01"+coolTemperature+setting_mode+"01"+heatTemperature+autoTemperature+dryTemperature
            let payload=set_packet
            let get_crc=crc_calculator.payload(payload)
            let send_packet=set_packet+get_crc
            let packet=helper.fullPacket(send_packet)
            let log_packet=helper.addSpace(packet)
            this.platform.log.debug(log_packet)
            send_to_server.udpclient(this.ip_address,packet)

           }else{

            this.platform.log.debug("Thermostat off mode excuted")
            
            let subnet_id=helper.numberToHex(this.subnet_id )
            let modify_channel_id=this.channel_id-1
            let device_id=helper.numberToHex(this.device_id) 
            let channel_id=helper.numberToHex(modify_channel_id) 
            
            let coolTemperature= helper.numberToHex(this.Thermostat.coolTemperature)
            let heatTemperature=helper.numberToHex(this.Thermostat.heatTemperature)
            let autoTemperature=helper.numberToHex(this.Thermostat.autoTemperature)
            let dryTemperature= helper.numberToHex(this.Thermostat.dryTemperature)
            let setting_mode= this.Thermostat.setting_mode
            this.Thermostat.currentmode=0
            let set_packet=String("1401fefffee0ee")+subnet_id+device_id+channel_id+"00"+coolTemperature+setting_mode+"01"+heatTemperature+autoTemperature+dryTemperature
            let payload=set_packet
            let get_crc=crc_calculator.payload(payload)
            let send_packet=set_packet+get_crc
            let packet=helper.fullPacket(send_packet)
            let log_packet=helper.addSpace(packet)
            this.platform.log.debug(log_packet)
            send_to_server.udpclient(this.ip_address,packet)


            this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.Thermostat.currentmode)
            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.Thermostat.currentmode)


           }

           if(value==1){

            let heatTemperature= this.Thermostat.heatTemperature
            this.service.updateCharacteristic(this.platform.Characteristic.TargetTemperature,heatTemperature)
            this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.Thermostat.currentmode)
            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.Thermostat.currentmode)
           
          }else if(value==2){
            
            let coolTemperature= this.Thermostat.coolTemperature
            this.service.updateCharacteristic(this.platform.Characteristic.TargetTemperature,coolTemperature)
            this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.Thermostat.currentmode)
            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.Thermostat.currentmode)

           }

           else if(value==3){
            
            let autoTemperature= this.Thermostat.autoTemperature
            this.service.updateCharacteristic(this.platform.Characteristic.TargetTemperature,autoTemperature)
            this.service.getCharacteristic(this.platform.Characteristic.CurrentHeatingCoolingState).updateValue(this.Thermostat.currentmode)
            this.service.getCharacteristic(this.platform.Characteristic.TargetHeatingCoolingState).updateValue(this.Thermostat.currentmode)

           }


      }

      async handleCurrentTemperatureGet() {
        this.platform.log.debug('Triggered GET CurrentTemperature');
    
        // set this to a valid value for CurrentTemperature
        const currentValue = this.Thermostat.THAmbient;
    
        return currentValue;
      }
    
      async handleTargetTemperatureGet() {
        this.platform.log.debug('Triggered GET TargetTemperature');
    
        // set this to a valid value for TargetTemperature
        const currentValue = this.Thermostat.THSetpoint;
    
        return currentValue;
      }


      async handleTargetTemperatureSet(value) {
        this.platform.log.debug('Triggered SET TargetTemperature:'+value);
        let setpoint =helper.numberToHex(value)

        if(this.Thermostat.currentmode==1){

          this.Thermostat.heatTemperature=value
        }
        else if(this.Thermostat.currentmode==2){

          this.Thermostat.coolTemperature=value
        }
        else if(this.Thermostat.currentmode==3){
          
          this.Thermostat.autoTemperature=value
          
        }else
        {
          return 0
        }


        let subnet_id=helper.numberToHex(this.subnet_id )
        let modify_channel_id=this.channel_id-1
        let device_id=helper.numberToHex(this.device_id) 
        let channel_id=helper.numberToHex(modify_channel_id)
        let coolTemperature= helper.numberToHex(this.Thermostat.coolTemperature)
        let heatTemperature=helper.numberToHex(this.Thermostat.heatTemperature)
        let autoTemperature=helper.numberToHex(this.Thermostat.autoTemperature)
        let dryTemperature= helper.numberToHex(this.Thermostat.dryTemperature)
        let setting_mode= this.Thermostat.setting_mode

        // this.platform.log.debug("------------------------------Setpoint Start ----------------")

        // this.platform.log.debug("coolTemperature "+coolTemperature)
        // this.platform.log.debug("heatTemperature "+heatTemperature)
        // this.platform.log.debug("autoTemperature "+autoTemperature)
        // this.platform.log.debug("dryTemperature "+dryTemperature)
        // this.platform.log.debug("setting_mode "+setting_mode)

        // this.platform.log.debug("------------------------------Setpoint End ----------------")

        let set_packet=String("1401fefffee0ee")+subnet_id+device_id+channel_id+"01"+coolTemperature+setting_mode+"01"+heatTemperature+autoTemperature+dryTemperature
        let payload=set_packet
        let get_crc=crc_calculator.payload(payload)
        let send_packet=set_packet+get_crc
        let packet=helper.fullPacket(send_packet)
        let log_packet=helper.addSpace(packet)
        this.platform.log.debug(log_packet)
        send_to_server.udpclient(this.ip_address,packet)





      }

      async handleTemperatureDisplayUnitsGet() {
        this.platform.log.debug('Triggered GET TemperatureDisplayUnits');
    
        // set this to a valid value for TemperatureDisplayUnits
        const currentValue =  this.Thermostat.Scale;
    
        return currentValue;
      }

      async handleTemperatureDisplayUnitsSet(value) {
        this.platform.log.debug('Triggered SET TemperatureDisplayUnits:'+value);
      }



}
exports.Thermostat = Thermostat;