'use strict';

const dgram = require('dgram');
const TISReceiver = require("./TISReceiver");


class UDPSERVER
{

constructor(){
this.server = dgram.createSocket('udp4');
    
this.server.on('error', (err) => {
  //console.log(`udp server error:\n${err.stack}`);
 this.server.close();
});

this.server.on('message', (msg, rinfo) => {
  //console.log(`server received udp: ${msg} from ${rinfo.address}`);
  new TISReceiver.TISReceiver()
});

this.server.on('listening', () => {
    const address = this.server.address();
    //console.log(`server listening ${address.address}:${address.port}`);
  });

this.server.bind(6000);

    }
}

exports.UDPSERVER = UDPSERVER;